// naumann@stce.rwth-aachen.de

#include<cmath>

template<typename T>
void f_t(T &x, T &x_t, const T &p, const T &p_t, const T &w, const T &w_t) {
  T f1_t=cos(x)*x_t; T f1=sin(x);
  T  f2_t=-sin(x)*x_t; T f2=cos(x);
  T aux=exp(-(x-p)/w);
  x_t=-pow(1./(1.+aux),2)*aux*(-x_t/w+p_t/w+w_t*(x-p)/pow(w,2));
  x=1./(1.+aux);
  x_t=f1_t*(1-x)-f1*x_t+f2_t*x+f2*x_t;
  x=f1*(1-x)+f2*x;
}
